commit 1122b1866f496124b346b75ff955be240553d28c
Author: Ken Gaillot <kgaillot@redhat.com>
Date:   Tue Jul 19 15:10:27 2016 -0500

    Test: pengine: update regression tests for new unfence ordering

Index: pacemaker/pengine/test10/unfence-definition.dot
===================================================================
--- pacemaker.orig/pengine/test10/unfence-definition.dot
+++ pacemaker/pengine/test10/unfence-definition.dot
@@ -12,8 +12,6 @@ digraph "g" {
 "clvmd-clone_stop_0" [ style=bold color="green" fontcolor="orange"]
 "clvmd-clone_stopped_0" -> "clvmd-clone_start_0" [ style = bold]
 "clvmd-clone_stopped_0" -> "dlm-clone_stop_0" [ style = bold]
-"clvmd-clone_stopped_0" -> "stonith 'on' virt-1" [ style = bold]
-"clvmd-clone_stopped_0" -> "stonith 'on' virt-3" [ style = bold]
 "clvmd-clone_stopped_0" [ style=bold color="green" fontcolor="orange"]
 "clvmd:1_monitor_0 virt-2" -> "probe_complete virt-2" [ style = bold]
 "clvmd:1_monitor_0 virt-2" [ style=bold color="green" fontcolor="black"]
@@ -32,6 +30,7 @@ digraph "g" {
 "clvmd_stop_0 virt-1" -> "clvmd-clone_stopped_0" [ style = bold]
 "clvmd_stop_0 virt-1" -> "clvmd_start_0 virt-1" [ style = bold]
 "clvmd_stop_0 virt-1" -> "dlm_stop_0 virt-1" [ style = bold]
+"clvmd_stop_0 virt-1" -> "stonith 'on' virt-1" [ style = bold]
 "clvmd_stop_0 virt-1" [ style=bold color="green" fontcolor="black"]
 "dlm-clone_running_0" -> "clvmd-clone_start_0" [ style = bold]
 "dlm-clone_running_0" [ style=bold color="green" fontcolor="orange"]
@@ -43,8 +42,6 @@ digraph "g" {
 "dlm-clone_stop_0" -> "dlm_stop_0 virt-1" [ style = bold]
 "dlm-clone_stop_0" [ style=bold color="green" fontcolor="orange"]
 "dlm-clone_stopped_0" -> "dlm-clone_start_0" [ style = bold]
-"dlm-clone_stopped_0" -> "stonith 'on' virt-1" [ style = bold]
-"dlm-clone_stopped_0" -> "stonith 'on' virt-3" [ style = bold]
 "dlm-clone_stopped_0" [ style=bold color="green" fontcolor="orange"]
 "dlm:2_monitor_0 virt-3" -> "probe_complete virt-3" [ style = bold]
 "dlm:2_monitor_0 virt-3" -> "stonith 'on' virt-3" [ style = bold]
@@ -58,6 +55,7 @@ digraph "g" {
 "dlm_stop_0 virt-1" -> "all_stopped" [ style = bold]
 "dlm_stop_0 virt-1" -> "dlm-clone_stopped_0" [ style = bold]
 "dlm_stop_0 virt-1" -> "dlm_start_0 virt-1" [ style = bold]
+"dlm_stop_0 virt-1" -> "stonith 'on' virt-1" [ style = bold]
 "dlm_stop_0 virt-1" [ style=bold color="green" fontcolor="black"]
 "fencing_delete_0 virt-1" -> "fencing_start_0 virt-1" [ style = bold]
 "fencing_delete_0 virt-1" [ style=bold color="green" fontcolor="black"]
@@ -84,11 +82,11 @@ digraph "g" {
 "probe_complete" -> "fencing_start_0 virt-1" [ style = bold]
 "probe_complete" -> "fencing_stop_0 virt-1" [ style = bold]
 "probe_complete" [ style=bold color="green" fontcolor="orange"]
-"stonith 'on' virt-1" -> "clvmd-clone_start_0" [ style = bold]
-"stonith 'on' virt-1" -> "dlm-clone_start_0" [ style = bold]
+"stonith 'on' virt-1" -> "clvmd_start_0 virt-1" [ style = bold]
+"stonith 'on' virt-1" -> "dlm_start_0 virt-1" [ style = bold]
 "stonith 'on' virt-1" [ style=bold color="green" fontcolor="black"]
-"stonith 'on' virt-3" -> "clvmd-clone_start_0" [ style = bold]
-"stonith 'on' virt-3" -> "dlm-clone_start_0" [ style = bold]
+"stonith 'on' virt-3" -> "clvmd:2_start_0 virt-3" [ style = bold]
+"stonith 'on' virt-3" -> "dlm:2_start_0 virt-3" [ style = bold]
 "stonith 'on' virt-3" -> "fencing_monitor_0 virt-3" [ style = bold]
 "stonith 'on' virt-3" [ style=bold color="green" fontcolor="black"]
 "stonith 'reboot' virt-4" -> "stonith_complete" [ style = bold]
Index: pacemaker/pengine/test10/unfence-parameters.dot
===================================================================
--- pacemaker.orig/pengine/test10/unfence-parameters.dot
+++ pacemaker/pengine/test10/unfence-parameters.dot
@@ -12,9 +12,6 @@ digraph "g" {
 "clvmd-clone_stop_0" [ style=bold color="green" fontcolor="orange"]
 "clvmd-clone_stopped_0" -> "clvmd-clone_start_0" [ style = bold]
 "clvmd-clone_stopped_0" -> "dlm-clone_stop_0" [ style = bold]
-"clvmd-clone_stopped_0" -> "stonith 'on' virt-1" [ style = bold]
-"clvmd-clone_stopped_0" -> "stonith 'on' virt-2" [ style = bold]
-"clvmd-clone_stopped_0" -> "stonith 'on' virt-3" [ style = bold]
 "clvmd-clone_stopped_0" [ style=bold color="green" fontcolor="orange"]
 "clvmd:1_monitor_0 virt-2" -> "probe_complete virt-2" [ style = bold]
 "clvmd:1_monitor_0 virt-2" -> "stonith 'on' virt-2" [ style = bold]
@@ -37,6 +34,7 @@ digraph "g" {
 "clvmd_stop_0 virt-1" -> "clvmd-clone_stopped_0" [ style = bold]
 "clvmd_stop_0 virt-1" -> "clvmd_start_0 virt-1" [ style = bold]
 "clvmd_stop_0 virt-1" -> "dlm_stop_0 virt-1" [ style = bold]
+"clvmd_stop_0 virt-1" -> "stonith 'on' virt-1" [ style = bold]
 "clvmd_stop_0 virt-1" [ style=bold color="green" fontcolor="black"]
 "dlm-clone_running_0" -> "clvmd-clone_start_0" [ style = bold]
 "dlm-clone_running_0" [ style=bold color="green" fontcolor="orange"]
@@ -50,9 +48,6 @@ digraph "g" {
 "dlm-clone_stop_0" -> "dlm_stop_0 virt-2" [ style = bold]
 "dlm-clone_stop_0" [ style=bold color="green" fontcolor="orange"]
 "dlm-clone_stopped_0" -> "dlm-clone_start_0" [ style = bold]
-"dlm-clone_stopped_0" -> "stonith 'on' virt-1" [ style = bold]
-"dlm-clone_stopped_0" -> "stonith 'on' virt-2" [ style = bold]
-"dlm-clone_stopped_0" -> "stonith 'on' virt-3" [ style = bold]
 "dlm-clone_stopped_0" [ style=bold color="green" fontcolor="orange"]
 "dlm:2_monitor_0 virt-3" -> "probe_complete virt-3" [ style = bold]
 "dlm:2_monitor_0 virt-3" -> "stonith 'on' virt-3" [ style = bold]
@@ -72,11 +67,13 @@ digraph "g" {
 "dlm_stop_0 virt-1" -> "all_stopped" [ style = bold]
 "dlm_stop_0 virt-1" -> "dlm-clone_stopped_0" [ style = bold]
 "dlm_stop_0 virt-1" -> "dlm_start_0 virt-1" [ style = bold]
+"dlm_stop_0 virt-1" -> "stonith 'on' virt-1" [ style = bold]
 "dlm_stop_0 virt-1" [ style=bold color="green" fontcolor="black"]
 "dlm_stop_0 virt-2" -> "all_stopped" [ style = bold]
 "dlm_stop_0 virt-2" -> "dlm-clone_stopped_0" [ style = bold]
 "dlm_stop_0 virt-2" -> "dlm_start_0 virt-2" [ style = bold]
 "dlm_stop_0 virt-2" -> "dlm_stop_0 virt-1" [ style = bold]
+"dlm_stop_0 virt-2" -> "stonith 'on' virt-2" [ style = bold]
 "dlm_stop_0 virt-2" [ style=bold color="green" fontcolor="black"]
 "fencing_monitor_0 virt-3" -> "fencing_start_0 virt-1" [ style = bold]
 "fencing_monitor_0 virt-3" [ style=bold color="green" fontcolor="black"]
@@ -103,14 +100,14 @@ digraph "g" {
 "probe_complete" -> "fencing_start_0 virt-1" [ style = bold]
 "probe_complete" -> "fencing_stop_0 virt-1" [ style = bold]
 "probe_complete" [ style=bold color="green" fontcolor="orange"]
-"stonith 'on' virt-1" -> "clvmd-clone_start_0" [ style = bold]
-"stonith 'on' virt-1" -> "dlm-clone_start_0" [ style = bold]
+"stonith 'on' virt-1" -> "clvmd_start_0 virt-1" [ style = bold]
+"stonith 'on' virt-1" -> "dlm_start_0 virt-1" [ style = bold]
 "stonith 'on' virt-1" [ style=bold color="green" fontcolor="black"]
-"stonith 'on' virt-2" -> "clvmd-clone_start_0" [ style = bold]
-"stonith 'on' virt-2" -> "dlm-clone_start_0" [ style = bold]
+"stonith 'on' virt-2" -> "clvmd:1_start_0 virt-2" [ style = bold]
+"stonith 'on' virt-2" -> "dlm_start_0 virt-2" [ style = bold]
 "stonith 'on' virt-2" [ style=bold color="green" fontcolor="black"]
-"stonith 'on' virt-3" -> "clvmd-clone_start_0" [ style = bold]
-"stonith 'on' virt-3" -> "dlm-clone_start_0" [ style = bold]
+"stonith 'on' virt-3" -> "clvmd:2_start_0 virt-3" [ style = bold]
+"stonith 'on' virt-3" -> "dlm:2_start_0 virt-3" [ style = bold]
 "stonith 'on' virt-3" -> "fencing_monitor_0 virt-3" [ style = bold]
 "stonith 'on' virt-3" [ style=bold color="green" fontcolor="black"]
 "stonith 'reboot' virt-4" -> "stonith_complete" [ style = bold]
Index: pacemaker/pengine/test10/unfence-startup.summary
===================================================================
--- pacemaker.orig/pengine/test10/unfence-startup.summary
+++ pacemaker/pengine/test10/unfence-startup.summary
@@ -18,6 +18,7 @@ Transition Summary:
 
 Executing cluster transition:
  * Resource action: dlm             monitor on virt-3
+ * Pseudo action:   dlm-clone_start_0
  * Resource action: clvmd           monitor on virt-2
  * Resource action: clvmd           monitor on virt-3
  * Fencing virt-4 (reboot)
@@ -26,7 +27,6 @@ Executing cluster transition:
  * Fencing virt-3 (on)
  * Pseudo action:   all_stopped
  * Resource action: fencing         monitor on virt-3
- * Pseudo action:   dlm-clone_start_0
  * Resource action: dlm             start on virt-3
  * Pseudo action:   dlm-clone_running_0
  * Pseudo action:   clvmd-clone_start_0
Index: pacemaker/pengine/test10/unfence-definition.exp
===================================================================
--- pacemaker.orig/pengine/test10/unfence-definition.exp
+++ pacemaker/pengine/test10/unfence-definition.exp
@@ -72,6 +72,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="2" operation="stonith" operation_key="stonith-virt-1-on" on_node="virt-1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="8" operation="probe_complete" operation_key="probe_complete"/>
       </trigger>
       <trigger>
@@ -113,6 +116,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="8" operation="probe_complete" operation_key="probe_complete"/>
       </trigger>
       <trigger>
@@ -185,12 +191,6 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="2" operation="stonith" operation_key="stonith-virt-1-on" on_node="virt-1" on_node_uuid="1"/>
-      </trigger>
-      <trigger>
-        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
-      </trigger>
-      <trigger>
         <pseudo_event id="25" operation="stopped" operation_key="dlm-clone_stopped_0"/>
       </trigger>
     </inputs>
@@ -204,6 +204,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="2" operation="stonith" operation_key="stonith-virt-1-on" on_node="virt-1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="8" operation="probe_complete" operation_key="probe_complete"/>
       </trigger>
       <trigger>
@@ -276,6 +279,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="8" operation="probe_complete" operation_key="probe_complete"/>
       </trigger>
       <trigger>
@@ -353,12 +359,6 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="2" operation="stonith" operation_key="stonith-virt-1-on" on_node="virt-1" on_node_uuid="1"/>
-      </trigger>
-      <trigger>
-        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
-      </trigger>
-      <trigger>
         <pseudo_event id="23" operation="running" operation_key="dlm-clone_running_0"/>
       </trigger>
       <trigger>
@@ -452,12 +452,6 @@
       <trigger>
         <rsc_op id="15" operation="monitor" operation_key="clvmd:2_monitor_0" on_node="virt-3" on_node_uuid="3"/>
       </trigger>
-      <trigger>
-        <pseudo_event id="25" operation="stopped" operation_key="dlm-clone_stopped_0"/>
-      </trigger>
-      <trigger>
-        <pseudo_event id="33" operation="stopped" operation_key="clvmd-clone_stopped_0"/>
-      </trigger>
     </inputs>
   </synapse>
   <synapse id="29">
@@ -468,10 +462,10 @@
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="25" operation="stopped" operation_key="dlm-clone_stopped_0"/>
+        <rsc_op id="17" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:0_stop_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
       <trigger>
-        <pseudo_event id="33" operation="stopped" operation_key="clvmd-clone_stopped_0"/>
+        <rsc_op id="26" operation="stop" operation_key="clvmd_stop_0" internal_operation_key="clvmd:0_stop_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
     </inputs>
   </synapse>
Index: pacemaker/pengine/test10/unfence-definition.summary
===================================================================
--- pacemaker.orig/pengine/test10/unfence-definition.summary
+++ pacemaker/pengine/test10/unfence-definition.summary
@@ -27,6 +27,8 @@ Executing cluster transition:
  * Fencing virt-4 (reboot)
  * Pseudo action:   stonith_complete
  * Pseudo action:   probe_complete
+ * Fencing virt-3 (on)
+ * Resource action: fencing         monitor on virt-3
  * Resource action: fencing         stop on virt-1
  * Resource action: clvmd           stop on virt-1
  * Pseudo action:   clvmd-clone_stopped_0
@@ -34,11 +36,9 @@ Executing cluster transition:
  * Pseudo action:   dlm-clone_stop_0
  * Resource action: dlm             stop on virt-1
  * Pseudo action:   dlm-clone_stopped_0
- * Fencing virt-3 (on)
+ * Pseudo action:   dlm-clone_start_0
  * Fencing virt-1 (on)
  * Pseudo action:   all_stopped
- * Resource action: fencing         monitor on virt-3
- * Pseudo action:   dlm-clone_start_0
  * Resource action: fencing         start on virt-1
  * Resource action: dlm             start on virt-1
  * Resource action: dlm             start on virt-3
Index: pacemaker/pengine/test10/unfence-parameters.exp
===================================================================
--- pacemaker.orig/pengine/test10/unfence-parameters.exp
+++ pacemaker/pengine/test10/unfence-parameters.exp
@@ -56,6 +56,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="2" operation="stonith" operation_key="stonith-virt-1-on" on_node="virt-1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="7" operation="probe_complete" operation_key="probe_complete"/>
       </trigger>
       <trigger>
@@ -100,6 +103,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="3" operation="stonith" operation_key="stonith-virt-2-on" on_node="virt-2" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="7" operation="probe_complete" operation_key="probe_complete"/>
       </trigger>
       <trigger>
@@ -141,6 +147,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="7" operation="probe_complete" operation_key="probe_complete"/>
       </trigger>
       <trigger>
@@ -222,15 +231,6 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="2" operation="stonith" operation_key="stonith-virt-1-on" on_node="virt-1" on_node_uuid="1"/>
-      </trigger>
-      <trigger>
-        <crm_event id="3" operation="stonith" operation_key="stonith-virt-2-on" on_node="virt-2" on_node_uuid="2"/>
-      </trigger>
-      <trigger>
-        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
-      </trigger>
-      <trigger>
         <pseudo_event id="24" operation="stopped" operation_key="dlm-clone_stopped_0"/>
       </trigger>
     </inputs>
@@ -244,6 +244,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="2" operation="stonith" operation_key="stonith-virt-1-on" on_node="virt-1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="7" operation="probe_complete" operation_key="probe_complete"/>
       </trigger>
       <trigger>
@@ -285,6 +288,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="3" operation="stonith" operation_key="stonith-virt-2-on" on_node="virt-2" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="7" operation="probe_complete" operation_key="probe_complete"/>
       </trigger>
       <trigger>
@@ -319,6 +325,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="7" operation="probe_complete" operation_key="probe_complete"/>
       </trigger>
       <trigger>
@@ -396,15 +405,6 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="2" operation="stonith" operation_key="stonith-virt-1-on" on_node="virt-1" on_node_uuid="1"/>
-      </trigger>
-      <trigger>
-        <crm_event id="3" operation="stonith" operation_key="stonith-virt-2-on" on_node="virt-2" on_node_uuid="2"/>
-      </trigger>
-      <trigger>
-        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
-      </trigger>
-      <trigger>
         <pseudo_event id="22" operation="running" operation_key="dlm-clone_running_0"/>
       </trigger>
       <trigger>
@@ -498,12 +498,6 @@
       <trigger>
         <rsc_op id="14" operation="monitor" operation_key="clvmd:2_monitor_0" on_node="virt-3" on_node_uuid="3"/>
       </trigger>
-      <trigger>
-        <pseudo_event id="24" operation="stopped" operation_key="dlm-clone_stopped_0"/>
-      </trigger>
-      <trigger>
-        <pseudo_event id="32" operation="stopped" operation_key="clvmd-clone_stopped_0"/>
-      </trigger>
     </inputs>
   </synapse>
   <synapse id="30">
@@ -517,10 +511,7 @@
         <rsc_op id="10" operation="monitor" operation_key="clvmd:1_monitor_0" on_node="virt-2" on_node_uuid="2"/>
       </trigger>
       <trigger>
-        <pseudo_event id="24" operation="stopped" operation_key="dlm-clone_stopped_0"/>
-      </trigger>
-      <trigger>
-        <pseudo_event id="32" operation="stopped" operation_key="clvmd-clone_stopped_0"/>
+        <rsc_op id="18" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:1_stop_0" on_node="virt-2" on_node_uuid="2"/>
       </trigger>
     </inputs>
   </synapse>
@@ -532,10 +523,10 @@
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="24" operation="stopped" operation_key="dlm-clone_stopped_0"/>
+        <rsc_op id="16" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:0_stop_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
       <trigger>
-        <pseudo_event id="32" operation="stopped" operation_key="clvmd-clone_stopped_0"/>
+        <rsc_op id="25" operation="stop" operation_key="clvmd_stop_0" internal_operation_key="clvmd:0_stop_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
     </inputs>
   </synapse>
Index: pacemaker/pengine/test10/unfence-parameters.summary
===================================================================
--- pacemaker.orig/pengine/test10/unfence-parameters.summary
+++ pacemaker/pengine/test10/unfence-parameters.summary
@@ -28,20 +28,20 @@ Executing cluster transition:
  * Fencing virt-4 (reboot)
  * Pseudo action:   stonith_complete
  * Pseudo action:   probe_complete
+ * Fencing virt-3 (on)
  * Resource action: fencing         stop on virt-1
+ * Resource action: fencing         monitor on virt-3
  * Resource action: clvmd           stop on virt-1
  * Pseudo action:   clvmd-clone_stopped_0
  * Pseudo action:   dlm-clone_stop_0
  * Resource action: dlm             stop on virt-2
+ * Fencing virt-2 (on)
  * Resource action: dlm             stop on virt-1
  * Pseudo action:   dlm-clone_stopped_0
- * Fencing virt-3 (on)
- * Fencing virt-2 (on)
+ * Pseudo action:   dlm-clone_start_0
  * Fencing virt-1 (on)
  * Pseudo action:   all_stopped
- * Resource action: fencing         monitor on virt-3
  * Resource action: fencing         start on virt-1
- * Pseudo action:   dlm-clone_start_0
  * Resource action: dlm             start on virt-1
  * Resource action: dlm             start on virt-2
  * Resource action: dlm             start on virt-3
Index: pacemaker/pengine/test10/unfence-startup.dot
===================================================================
--- pacemaker.orig/pengine/test10/unfence-startup.dot
+++ pacemaker/pengine/test10/unfence-startup.dot
@@ -37,8 +37,8 @@ digraph "g" {
 "probe_complete" -> "clvmd:2_start_0 virt-3" [ style = bold]
 "probe_complete" -> "dlm:2_start_0 virt-3" [ style = bold]
 "probe_complete" [ style=bold color="green" fontcolor="orange"]
-"stonith 'on' virt-3" -> "clvmd-clone_start_0" [ style = bold]
-"stonith 'on' virt-3" -> "dlm-clone_start_0" [ style = bold]
+"stonith 'on' virt-3" -> "clvmd:2_start_0 virt-3" [ style = bold]
+"stonith 'on' virt-3" -> "dlm:2_start_0 virt-3" [ style = bold]
 "stonith 'on' virt-3" -> "fencing_monitor_0 virt-3" [ style = bold]
 "stonith 'on' virt-3" [ style=bold color="green" fontcolor="black"]
 "stonith 'reboot' virt-4" -> "stonith_complete" [ style = bold]
Index: pacemaker/pengine/test10/unfence-startup.exp
===================================================================
--- pacemaker.orig/pengine/test10/unfence-startup.exp
+++ pacemaker/pengine/test10/unfence-startup.exp
@@ -21,6 +21,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="6" operation="probe_complete" operation_key="probe_complete"/>
       </trigger>
       <trigger>
@@ -61,11 +64,7 @@
         <attributes CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
       </pseudo_event>
     </action_set>
-    <inputs>
-      <trigger>
-        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
-      </trigger>
-    </inputs>
+    <inputs/>
   </synapse>
   <synapse id="5">
     <action_set>
@@ -104,6 +103,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="6" operation="probe_complete" operation_key="probe_complete"/>
       </trigger>
       <trigger>
@@ -155,9 +157,6 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
-      </trigger>
-      <trigger>
         <pseudo_event id="22" operation="running" operation_key="dlm-clone_running_0"/>
       </trigger>
     </inputs>